#include "OLED.h"
#include "nucleo_i2c.h"

void OLEDInit_SW(void)
{
	OLED_WriteCmd(0xAE);                    // 0xAE
	OLED_WriteCmd(0xd5);            // 0xD5
	OLED_WriteCmd(0x80);                                  // the suggested ratio 0x80

	OLED_WriteCmd(0xa8);                  // 0xA8
	OLED_WriteCmd(64 - 1);

	OLED_WriteCmd(0xd3);              // 0xD3
	OLED_WriteCmd(0x0);                                   // no offset
	OLED_WriteCmd(0);            // line #0
	OLED_WriteCmd(0x8d);                    // 0x8D
	OLED_WriteCmd(0x14);

	OLED_WriteCmd(0x20);                    // 0x20
	OLED_WriteCmd(0x00);                                  // 0x0 act like ks0108
	OLED_WriteCmd(0xa0 | 0x1);
	OLED_WriteCmd(0xc8);

	OLED_WriteCmd(0xda);                    // 0xDA
	OLED_WriteCmd(0x12);
	OLED_WriteCmd(0x81);                   // 0x81
	OLED_WriteCmd(0xCF);

	OLED_WriteCmd(0xd9);                  // 0xd9
	OLED_WriteCmd(0xF1);

	OLED_WriteCmd(0xd8);                 // 0xDB
	OLED_WriteCmd(0x40);
	OLED_WriteCmd(0xa4);           // 0xA4
	OLED_WriteCmd(0xa6);                 // 0xA6

	//  MiniOLED_WriteCmd(SSD1306_DEACTIVATE_SCROLL);

	OLED_WriteCmd(0xaf);
}

void ON_OFF(uint8_t onoff)
{
	for (uint8_t page = 0; page < (SSD1306_OLEDHEIGHT/SSD1306_PAGESIZE); page++)
	{
		setCursor(0,page);
		for (uint8_t col = 0; col < SSD1306_OLEDWIDTH; col++)
		{
			OLED_WriteData(onoff);
		}
	}
	setCursor(0,0);
}

void setCursor(uint8_t x, uint8_t y)
{
	OLED_WriteCmd(SSD1306_SETLOWCOLUMN + (x & 0x0F));
	OLED_WriteCmd(SSD1306_SETHIGHCOLUMN + ((x >> 4) & 0x0F));
	OLED_WriteCmd(SSD1306_SETPAGESTART + y);
}

void showData(bool pole[SSD1306_OLEDHEIGHT][SSD1306_OLEDWIDTH],int pagesize, int height, int width)
{
	uint8_t toPut = 0;
	for (int h = 0;h<height/pagesize;h++)
	{
		setCursor(0,h);
		for (int g = 0;g<width;g++)
		{
			for (int i = 0;i<pagesize;i++)
			{
				toPut |= pole[i+(h*pagesize)][g] << i;
			}
			OLED_WriteData(toPut);
			toPut = 0;
		}
	}
}
