#ifndef OLED_H_
#define OLED_H_

#include <stdbool.h>
#include <stdint.h>

#define SSD1306_OLEDWIDTH 128
#define SSD1306_OLEDHEIGHT 64
#define SSD1306_PAGESIZE 8

#define SSD1306_SETLOWCOLUMN 0x00
#define SSD1306_SETHIGHCOLUMN 0x10
#define SSD1306_MEMORYMODE 0x20
#define SSD1306_DISPLAYOFF 0xAE
#define SSD1306_DISPLAYON 0xAF
#define SSD1306_SETPAGESTART 0xB0

#define ON	0xFF
#define OFF	0x00

void ON_OFF(uint8_t onoff);
void setCursor(uint8_t x, uint8_t y);
void showData(bool pole[SSD1306_OLEDHEIGHT][SSD1306_OLEDWIDTH], int pagesize, int height, int width);
void OLEDInit_SW(void);

#endif /* OLED_H_ */
