#include "OLED.h"
#include "SPI.h"

void OLEDInit_SW(void)
{
   uint32_t tm = 0;

   OLED_RESET_LOW;
   for(tm = 0; tm < 50000; tm++)
     asm("nop");

   OLED_RESET_HIGH;
   for(tm = 0; tm < 10000; tm++)
     asm("nop");

   OLED_DC_LOW;
   OLED_CS_LOW;
   OLED_WriteCmd(SSD1305_DISPLAYON);
   OLED_WriteCmd(SSD1305_MEMORYMODE);
   OLED_CS_HIGH;
}

void ON_OFF(uint8_t onoff)
{
	for (uint8_t page = 0; page < SSD1305_PAGESIZE; page++)
	{
		setCursor(0,page);
		for (uint8_t col = 0; col < SSD1305_OLEDWIDTH; col++)
		{
			OLED_WriteData(onoff);
		}
	}
	setCursor(0,0);
}

void setCursor(uint8_t x, uint8_t y)
{
	OLED_WriteCmd(SSD1305_SETLOWCOLUMN + x);
	OLED_WriteCmd(SSD1305_SETHIGHCOLUMN + (x >> 4));
	OLED_WriteCmd(SSD1305_SETPAGESTART + y);
}

void showData(bool pole[SSD1305_OLEDHEIGHT][SSD1305_OLEDWIDTH],int pagesize, int height, int width)
{
	uint8_t toPut = 0;
	for (int h = 0;h<height/pagesize;h++)
	{
		setCursor(0,h);
		for (int g = 0;g<width;g++)
		{
			for (int i = 0;i<pagesize;i++)
			{
				if (pole[i+(h*pagesize)][g])
				{
					toPut |= 1 << i;
				}
			}
			OLED_WriteData(toPut);
			toPut = 0;
		}
	}
}
