#ifndef OLED_H_
#define OLED_H_

#include <stdbool.h>
#include <stdint.h>

#define SSD1305_OLEDWIDTH 128
#define SSD1305_OLEDHEIGHT 32
#define SSD1305_PAGESIZE 8

#define SSD1305_SETLOWCOLUMN 0x00
#define SSD1305_SETHIGHCOLUMN 0x10
#define SSD1305_MEMORYMODE 0x20
#define SSD1305_DISPLAYOFF 0xAE
#define SSD1305_DISPLAYON 0xAF
#define SSD1305_SETPAGESTART 0xB0

#define ON	0xFF
#define OFF	0x00

void OLEDInit_SW(void);

void ON_OFF(uint8_t onoff);
void setCursor(uint8_t x, uint8_t y);
void showData(bool pole[SSD1305_OLEDHEIGHT][SSD1305_OLEDWIDTH], int pagesize, int height, int width);

#endif /* OLED_H_ */
