#ifndef SPI_H_
#define SPI_H_

#include "stm_core.h"

#define OLED_PIN_RESET  GPIOB, 10     // D6
#define OLED_PIN_DC   GPIOA, 8        // D7
#define OLED_PIN_CS   GPIOB, 6        // D10
#define OLED_PIN_SCK  GPIOA, 5        // D13
#define OLED_PIN_MOSI  GPIOA, 7       // D11

#define OLED_DC_HIGH GPIOWrite(GPIOA, 8, 1)
#define OLED_DC_LOW GPIOWrite(GPIOA, 8, 0)

#define OLED_CS_HIGH GPIOWrite(GPIOB, 6, 1)
#define OLED_CS_LOW GPIOWrite(GPIOB, 6, 0)


#define OLED_RESET_HIGH GPIOWrite(GPIOB, 10, 1)
#define OLED_RESET_LOW GPIOWrite(GPIOB, 10, 0)

void OLED_Write8(uint8_t b);
void OLEDInit_HW(void);
void OLED_WriteCmd(uint8_t cmd);
void OLED_WriteData(uint8_t data);

#endif /* SPI_H_ */
