#include "stm_core.h"
#include "OLED.h"
#include "SPI.h"


volatile uint32_t _ticks = 0;
void SysTick_Handler(void)
{
	_ticks++;
}

int main(void)
{
	SystemCoreClockUpdate();
	SysTick_Config(SystemCoreClock / 1000);
	uint32_t tm = 0;
	int letterCount = 0;
	OLEDInit_HW();
	int cursorPage = 0;
	int counterCol = 0;
	uint8_t mask = 1;
	OLEDInit_SW();

	uint8_t letter[26][5] = {
	{0x7e, 0x11, 0x11, 0x11, 0x7e},		//A
	{0x7f, 0x49, 0x49, 0x49, 0x36},		//B
	{0x3e, 0x41, 0x41, 0x41, 0x22},		//C
	{0x7f, 0x41, 0x41, 0x22, 0x1c},		//D
	{0x7f, 0x49, 0x49, 0x49, 0x41},		//E
	{0x7f, 0x09, 0x09, 0x09, 0x01},		//F
	{0x3e, 0x41, 0x49, 0x49, 0x7a},		//G
	{0x7f, 0x08, 0x08, 0x08, 0x7f},		//H
	{0x00, 0x41, 0x7f, 0x41, 0x00},		//I
	{0x20, 0x40, 0x41, 0x3f, 0x01},		//J
	{0x7f, 0x08, 0x14, 0x22, 0x41},		//K
	{0x7f, 0x40, 0x40, 0x40, 0x40},		//L
	{0x7f, 0x02, 0x0c, 0x02, 0x7f},		//M
	{0x7f, 0x04, 0x08, 0x10, 0x7f},		//N
	{0x3e, 0x41, 0x41, 0x41, 0x3e},		//O
	{0x7f, 0x09, 0x09, 0x09, 0x06},		//P
	{0x3e, 0x41, 0x51, 0x21, 0x5e},		//Q
	{0x7f, 0x09, 0x19, 0x29, 0x46},		//R
	{0x46, 0x49, 0x49, 0x49, 0x31},		//S
	{0x01, 0x01, 0x7f, 0x01, 0x01},		//T
	{0x3f, 0x40, 0x40, 0x40, 0x3f},		//U
	{0x1f, 0x20, 0x40, 0x20, 0x1f},		//V
	{0x3f, 0x40, 0x38, 0x40, 0x3f},		//W
	{0x63, 0x14, 0x08, 0x14, 0x63},		//X
	{0x07, 0x08, 0x70, 0x08, 0x07},		//Y
	{0x61, 0x51, 0x49, 0x45, 0x43}};	//Z

	bool toShow[SSD1305_OLEDHEIGHT][SSD1305_OLEDWIDTH] = {};
	ON_OFF(OFF);

	while(1)
	{
		if (_ticks >= tm)
		{
			for (int i = 0; i < 5; i++)
			{
				for (int j = 0; j < 8; j++)
				{
					mask = mask << j;
					if ((letter[letterCount][i] & mask) == mask)
					{
						toShow[j+(cursorPage*SSD1305_PAGESIZE)][counterCol] = 1;
					}
					else
					{
						toShow[j+(cursorPage*SSD1305_PAGESIZE)][counterCol] = 0;
					}
					mask = 1;
				}
				counterCol++;
			}

			for (int i = 0; i < 8; i++)
			{
				toShow[i+(cursorPage*SSD1305_PAGESIZE)][counterCol] = 0;
			}
			counterCol++;

			if ((counterCol + 6) > 128)
			{
				counterCol = 0;
				cursorPage++;
			}

			if (cursorPage == 4)
			{
				cursorPage = 0;
			}
			letterCount++;

			if (letterCount == 26)
			{
				letterCount = 0;
			}

			tm = _ticks + 200;
			showData(toShow, SSD1305_PAGESIZE, SSD1305_OLEDHEIGHT, SSD1305_OLEDWIDTH);
		}
	}
}
